proc AnzeigeAnlegen {worauf faktor} {
  #flicker Rahmen, Pfeile und Balken lt Sparkassenabbildung
  $worauf create polygon 20 20 230 20 230 140 20 140 -fill red \
	-joinstyle round -outline red -width 40 -tag display
  $worauf create polygon 25 25 225 25 225 135 25 135 -fill black \
	-joinstyle round -outline black -width 40 -tag display
  set startx 35; set i 0
  foreach bar {takt bit0 bit1 bit2 bit3} {
    $worauf create rectangle [expr $startx+$i*38] 35 \
	[expr $startx+($i+1)*38 - 8] 125 -fill white \
	-outline "" -tags "$bar display" 
    incr i	
  }
  #Positionierdreiecke anlegen
  $worauf create polygon [expr $startx+5] 18 [expr $startx+25] 18 \
	[expr $startx+15] 35 -fill lightgrey -outline "" -tag display
  set startx [expr $startx + 4*38]
  $worauf create polygon [expr $startx+5] 18 [expr $startx+25] 18 \
	[expr $startx+15] 35 -fill lightgrey -outline "" -tag display
  #auf gewuenschte Groesse skalieren, 0 0 ist Ursprung
  $worauf scale display 0 0 $faktor $faktor
}

frame .f -bg lightgrey
pack .f
label .f.title -text "chipTAN Flickercode" -font "Times 18 bold" \
	-bg lightgrey
pack .f.title -padx 40 -pady 20 -anchor w
label .f.subtitle -text "Nach einer Idee von Lars-Dominik Braun 6xq.net" -font "Times 14 bold"
pack .f.subtitle -padx 40 -pady 10 -anchor w

frame .f.zooms
pack .f.zooms -padx 40 -anchor w

image create photo zout -file "zoom_out.gif"
button .f.zooms.out -image zout -command {Skaliere .f.s -0.05}
pack .f.zooms.out -side left
image create photo zin -file "zoom_in.gif"
button .f.zooms.in -image zin -command {Skaliere .f.s 0.05}
pack .f.zooms.in -side left

set scale 1.0
canvas .f.s -width 250 -height 160 -bg lightgray
pack .f.s -padx 40 -anchor nw

#Display auf canvas mit Faktor 100% anzeigen
AnzeigeAnlegen .f.s $scale 

frame .f.e
pack .f.e -fill both -padx 40 -pady 10 -anchor w
label .f.e.konto -text "Empfngerkonto"
entry .f.e.kentry -textvariable EKonto \
	-background white
label .f.e.betrag -text "Betrag"
entry .f.e.bentry -textvariable Betrag \
	-background white
label .f.e.startcode -text "Startcode"
entry .f.e.sentry -textvariable  startcode \
	-background white

pack .f.e.konto .f.e.kentry .f.e.betrag .f.e.bentry \
	.f.e.startcode .f.e.sentry -side left


frame .f.buttons
pack .f.buttons -padx 40 -pady 10 -anchor w
button .f.buttons.start -text "Start" -width 7 \
	-command {set weiter true; showCode .f.s}
pack .f.buttons.start -side left -padx 5
button .f.buttons.stop -text "Stop" -width 7 \
	-command {set weiter false}
pack .f.buttons.stop -side left -padx 5
button .f.buttons.quit -text "Ende" -width 7 \
	-command {exit}
pack .f.buttons.quit -side left -padx 5

label .f.use -text "Eine Kontonummer, Betrag und Startcode eingeben\
	, dann Start drcken." \
	-font "Times 12 normal" -justify left
pack .f.use -anchor w -padx 40 -pady 10

set H(0) {0 0 0 0}; set H(1) {1 0 0 0}; set H(2) {0 1 0 0}
set H(3) {1 1 0 0}; set H(4) {0 0 1 0}; set H(5) {1 0 1 0}
set H(6) {0 1 1 0}; set H(7) {1 1 1 0}; set H(8) {0 0 0 1}
set H(9) {1 0 0 1}; set H(A) {0 1 0 1}; set H(B) {1 1 0 1}
set H(C) {0 0 1 1}; set H(D) {1 0 1 1}; set H(E) {0 1 1 1}
set H(F) {1 1 1 1}
set j 0
foreach hex {0 1 2 3 4 5 6 7 8 9 A B C D E F} {
  set hex2int($hex) $j
  set int2hex($j) $hex
  incr j
}


#Skalierung der Flickeranzeige
proc Skaliere {was increment} {
  global scale
  set scale [expr {$scale+$increment <= 0.1?0.1:$scale + $increment}]
  $was delete all
  $was configure -width [expr int(250*$scale)] \
	-height [expr int(160*$scale)]
  AnzeigeAnlegen $was $scale
}

proc qsum {n} {
  set s 0
  while {$n > 0} {
    set s [expr $s + ($n % 10)]; set n [expr int($n / 10)] 
  }
  return $s
}

proc computeLuhn {from} {
  global hex2int
  set luhn 0
  for {set i 0} {$i < [string length $from]} {incr i 2} {
    set luhn [expr $luhn + [qsum $hex2int([string index $from $i])] \
	+ [qsum [expr 2*$hex2int([string index $from [expr $i+1]]) ]]]
  }
  set luhn [expr (10 - ($luhn % 10)) % 10]
  return $luhn
}

proc computeXOR {from} {
  global hex2int int2hex
  set x 0
  for {set i 0} {$i < [string length $from]} {incr i} {
    set x [expr $x ^ $hex2int([string index $from $i])]
  }
  return $int2hex($x)
}

proc showCode {worauf} {
  global H weiter Betrag EKonto startcode int2hex
  #Uebertragungsstring berechnen
  if {![string is digit -strict $EKonto] || 
		[string length $EKonto] > 10} {
	set weiter false; set EKonto "Ungltige Zeichen"; update; 	return
  }
  #noch Pruefung Betrag (Komma, zwei Nachkommastellen)
  #set startcode 85126;# aus Folien - nur demo, ggf. Zufallszahl
  #Empfngerkonto mit Fuellnibble F wenn ungerade Stellenzahl
  if {([string length $EKonto] % 2) != 0} {
	append ek $EKonto "F"
	} else {set ek $EKonto}
  #set ek [format "%6s" $EKonto];# Laenge 6 ohne fhrenden Nullen
  binary scan $Betrag "H[expr 2*[string length $Betrag]]" hbetrag
  set hbetrag [string toupper $hbetrag]
  set was "04871"; append was $startcode "0" \
	[expr [string length $ek]/2] $ek "1" \
	$int2hex([string length $Betrag]) $hbetrag
  append payload "871" $startcode $ek $hbetrag
  append was2 $was [computeLuhn $payload] "F"
  set tlen [format "%02X" [expr [string length $was2]/2]]
  #0FFF und Laenge in Bytes als Hexzahl davor
  append tfinal 0FFF $tlen $was2
  #letzte Hexziffer durch richtigen XOR-Wert ersetzen
  #alle hexziffern ausser Sync und die beiden Prfziffern selbst

  set xor [computeXOR "$tlen$was"]
  set tfinal [string replace $tfinal end end $xor] 
  .f.use configure -text "tfinal = $tfinal"
  
  if {![string is xdigit -strict $tfinal]} {
	.f.use configure -text \
		"Fehler: $tfinal keine hexadezimale Zeichenfolge!" } else {
	while {$weiter} {
	  for {set i 0} {$i < [string length $tfinal]} {incr i 2} {
	    set c1 [string index $tfinal $i]  
	    set c2 [string index $tfinal [expr $i+1]]
	    #anzeigen in umgekehrter Reihenfolge!
	    ShowNibble $worauf [lindex $H($c2) 0] \
		[lindex $H($c2) 1] [lindex $H($c2) 2] \
		[lindex $H($c2) 3]
	    update
	    ShowNibble $worauf [lindex $H($c1) 0] \
		[lindex $H($c1) 1] [lindex $H($c1) 2] \
		[lindex $H($c1) 3]
	    update
	    if {!$weiter} {break}
        };#end for
	};#end while
  };# end else
}

proc ShowNibble {worauf b0 b1 b2 b3} {
  $worauf itemconfigure takt -fill white
  $worauf itemconfigure bit0 -fill [expr {$b0?"white":"black"}]
  $worauf itemconfigure bit1 -fill [expr {$b1?"white":"black"}]
  $worauf itemconfigure bit2 -fill [expr {$b2?"white":"black"}]
  $worauf itemconfigure bit3 -fill [expr {$b3?"white":"black"}]
  update
  after 50
  $worauf itemconfigure takt -fill {black}
  update
  after 50
}

set weiter true
ShowNibble .f.s 1 1 1 1
