#Notenzuteilungsprogramm - L. Wegner 2015

proc berechne {} {
	global pvon pbis pmax gunten goben 
	set pvon(n.b.) 0.0
	set pbis(n.b.) [expr [myround $gunten] - 0.5]
	set pvon(1.0) [myround $goben]
	set pbis(1.0) [myround $pmax]
	set intervall [expr ($goben - $gunten) / 9.0 ]
	.text insert end "VON\tBIS\tNOTE\n"
	.text insert end "$pvon(n.b.)\t$pbis(n.b.)\tn.b.\n"
	set starter $gunten
	foreach step "4.0 3.7 3.3 3.0 2.7 2.3 2.0 1.7 1.3" {
		set pvon($step) [myround $starter]
		set pbis($step) \
			[expr [myround [expr $starter + $intervall]] - 0.5]
		set starter [expr $starter + $intervall]
		.text insert end "$pvon($step)\t$pbis($step)\t$step\n"
	}
	.text insert end "$pvon(1.0)\t$pbis(1.0)\t1.0\n"
}

# ---

proc myround {f} {
	#round to nearest 0.5 value
	return [expr {round($f * 2.0) / 2.0}]
}

# ---

proc showstat {} {
	#je Teilnehmer Punkte in Note umrechnen und Statistik anzeigen
	global noten nteilnehmer pteilnehmer notenstatistik
	.s.c delete all
	.s.c create line 50 350 580 350 -width 2 -fill blue
	.s.c create line 50 350 50 50 -width 2 -fill blue

	foreach note $noten {set notenstatistik($note) 0}
	foreach teiln [array names pteilnehmer] {
		set nteilnehmer($teiln) [p2n $pteilnehmer($teiln)]
		incr notenstatistik($nteilnehmer($teiln))
	}
	set maxjenote 0
	foreach note $noten {
		if {$notenstatistik($note) > $maxjenote} {
			set maxjenote $notenstatistik($note)
		}
	}
	if {$maxjenote > 0} {set yincrement [expr 200 / $maxjenote]}
	for {set i 1} {$i <= $maxjenote} {incr i} {
		.s.c create text 30 [expr 350 - $yincrement * $i] -text $i
	}
	set i 90
	foreach note $noten {
		.s.c create text $i 380 -text $note
		if {$notenstatistik($note) > 0} {
			.s.c create rectangle [expr $i - 20] 350 [expr $i + 20] \
				[expr 350 - $yincrement * $notenstatistik($note)] \
				-fill red -outline ""
		}
		incr i 45
	}
}

# ---

set pmax 100
set goben 95
set gunten 50
set noten "n.b. 4.0 3.7 3.3 3.0 2.7 2.3 2.0 1.7 1.3 1.0" 
# moegliche Notenstufen

label .ueberschrift -text "Punktegrenzen eingeben und Start druecken"
grid .ueberschrift -columnspan 2

label .pmaxlabel -text "Punkte max."
entry .pmaxentry -width 20 -textvariable pmax -justify right
grid .pmaxlabel -column 0 -row 1 -padx 4 -pady 4 -sticky e
grid .pmaxentry -column 1 -row 1 -padx 4 -pady 4 -sticky w

label .gobenlabel -text "Note 1.0 ab" 
entry .gobenentry -width 20 -textvariable goben -justify right
grid .gobenlabel -column 0 -row 2 -padx 4 -pady 4 -sticky e
grid .gobenentry -column 1 -row 2 -padx 4 -pady 4 -sticky w

label .guntenlabel -text "Bestanden ab" 
entry .guntenentry -width 20 -textvariable gunten -justify right
grid .guntenlabel -column 0 -row 3 -padx 4 -pady 4 -sticky e
grid .guntenentry -column 1 -row 3 -padx 4 -pady 4 -sticky w

button .start -width 30 -bg "blue" -fg "white" -text "Start" \
	-command {.text delete 1.0 end; berechne; showstat}
button .exit -width 30 -bg "red" -fg "white" -text "Abbruch" \
	-command {exit}
grid .start .exit -padx 4 -pady 4

text .text -width 20 -height 12 -wrap none
grid .text -columnspan 2 -pady 4

button .ok -width 30 -bg "green" -fg "black" \
	-text "OK - Teilnehmereingabe starten" -command {teilnehmereingabe}
grid .ok -columnspan 2 -padx 4 -pady 8

# ---

toplevel .s
label .s.m -text "Notenstatistik"; pack .s.m -pady 10
canvas .s.c -width 600 -height 400 -bg white; pack .s.c

# ---

berechne
showstat

# ---

proc teilnehmereingabe {} {
	global pteilnehmer
	toplevel .t
	label .t.eingeben -text "Teilnehmer und Punkte eingeben" 
	grid .t.eingeben -columnspan 2

	label .t.namelabel -text "Name:" 
	entry .t.nameentry -width 20 -textvariable tname -justify left
	grid .t.namelabel -column 0 -row 1 -padx 4 -pady 4 -sticky e
	grid .t.nameentry -column 1 -row 1 -padx 4 -pady 4 -sticky w

	label .t.punktelabel -text "Erreichte Punkte:" 
	entry .t.punkteentry -width 20 -textvariable tpunkte -justify right
	grid .t.punktelabel -column 0 -row 2 -padx 4 -pady 4 -sticky e
	grid .t.punkteentry -column 1 -row 2 -padx 4 -pady 4 -sticky w

	button .t.weiter -width 30 -bg "blue" -fg "white" \
		-text "Speichern und weiter" -command {
		set pteilnehmer($tname) $tpunkte
		set tpunkte ""; set tname ""
		showstat }
	button .t.fertig -width 30 -bg "blue" -fg "white" \
		-text "Eingabe beenden" -command {destroy .t}
	grid .t.weiter .t.fertig -padx 4 -pady 4
}

# ---

proc p2n {p} {
	#berechne Note aus gegebener Punktzahl
	global pvon
	set n "n.b."
	foreach step "1.0 1.3 1.7 2.0 2.3 2.7 3.0 3.3 3.7 4.0" {
		if {$p >= $pvon($step)} {
			set n $step
			break
		}
	}
	return $n
}


